Package com.orchestranetworks.userservice

# Interface UserServiceWriter

All Superinterfaces:
  `UIBodyWriter`, `UIComponentWriter`, `UIDependencyRegisterer`, `UIJavaScriptWriter`, `UIResourceLocator`, `UISessionContext`, `UserServiceResourceLocator`

All Known Subinterfaces:
  `UserServicePaneWriter`, `UserServiceRawPaneWriter`

public interface UserServiceWriter extends UIComponentWriter, UserServiceResourceLocator
This interface provides methods for rendering a user service content.

Since:
  5.8.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addButton(UIButtonSpec aButton)`
  Adds a button.
  `UIButtonSpecNavigation`
  `newActionButton(UserMessage aLabel, UserServiceEvent aCallback)`
  Creates a specification for a localized action button.
  `UIButtonSpecNavigation`
  `newActionButton(String aLabel, UserServiceEvent aCallback)`
  Creates a specification for an action button.

  ### Methods inherited from interface com.orchestranetworks.ui.UIBodyWriter

  `add, add, add, add_cr, add_cr, addSafeAttribute, addSafeAttribute, addSafeInnerHTML, addSafeInnerHTML`

  ### Methods inherited from interface com.orchestranetworks.ui.UIComponentWriter

  `addButtonHelp, addButtonJavaScript, addButtonJavaScriptToggle, addUILabel, addUserAvatar, buildButtonPreview, buildButtonPreview, buildButtonPreview, endBorder, endExpandCollapseBlock, endFormGroup, endFormRow, endTableFormRow, newExpandCollapseBlock, newFormGroup, newFormRow, startBorder, startBorder, startBorder, startExpandCollapseBlock, startExpandCollapseBlock, startFormGroup, startFormGroup, startFormRow, startFormRow, startFormRow, startFormRow, startTableFormRow`

  ### Methods inherited from interface com.orchestranetworks.ui.UIDependencyRegisterer

  `addJavaScriptDependency`

  ### Methods inherited from interface com.orchestranetworks.ui.UIJavaScriptWriter

  `addJS, addJS_addResizeWorkspaceListener, addJS_cr, addJS_cr, addJS_openPreviewImage, addJS_openPreviewImageFromVar, addJS_setButtonDisabled, addJS_setExpandCollapseBlockExpanded, addJS_setStateToToggleButton, addJS_switchToPerspective, addJS_switchToPerspectiveAction`

  ### Methods inherited from interface com.orchestranetworks.ui.UIResourceLocator

  `createWebComponentForRootSession, createWebComponentForSubSession, getURLForAjaxComponent, getURLForAjaxComponent, getURLForPerspectiveSelection, getURLForPerspectiveSelection, getURLForResource, getURLForResource, getURLForResource, getURLForResource, getURLForResource, getURLForRest, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForViewSelection`

  ### Methods inherited from interface com.orchestranetworks.ui.UISessionContext

  `getLocale, getSession`

  ### Methods inherited from interface com.orchestranetworks.userservice.UserServiceResourceLocator

  `getURLForAction, getURLForAction, getURLForAjaxRequest, getURLForAjaxRequest, getURLForEndingService, getURLForGetRequest, getURLForGetRequest, getURLForResource, getURLForResource, getURLForServiceSelection, getURLForServiceSelection, getURLForServiceSelection, getURLForServiceSelection, getURLForServiceSelection, getURLForServiceSelection, getURLForServiceSelection, getURLForServiceSelection, getURLForServiceSelection`

- ## Method Details

  - ### newActionButton

    UIButtonSpecNavigation newActionButton(String aLabel, UserServiceEvent aCallback)
    Creates a specification for an action button.
    Parameters:
      `aLabel` - the button label.
      `aCallback` - the callback.
    Returns:
      the button specification.

  - ### newActionButton

    UIButtonSpecNavigation newActionButton(UserMessage aLabel, UserServiceEvent aCallback)
    Creates a specification for a localized action button.
    Parameters:
      `aLabel` - the button label.
      `aCallback` - the callback.
    Returns:
      the button specification.

  - ### addButton

    void addButton(UIButtonSpec aButton)
    Adds a button.
    Parameters:
      `aButton` - the button specification.